; constantes de dados
valor			EQU	76H	; valor cujo nmero de bits a 1  para ser contado
mscaraInicial	EQU	01H	; 0000 0001 em binrio (mscara inicial)
mscaraFinal	EQU	80H	; 1000 0000 em binrio (mscara final)

; constantes de endereos (na memria de dados)
contador		EQU	00H	; endereo da clula de memria que guarda 
					; o valor corrente do contador de bits a 1
mscara		EQU	01H	; endereo da clula de memria que guarda 
					; o valor corrente da mscara
; programa (memria de instrues)
incio:	LD	0		; Inicializa o registo A a zero
	ST	[contador]		; Inicializa o contador de bits com zero
	LD	mscaraInicial	; Carrega valor da mscara inicial
	ST	[mscara]		; actualiza na memria
teste:	AND	valor		; isola o bit que se quer ver se  1
	JZ	maisUm		; se o bit for zero, tem de incrementar o contador
	JMP	prximo		; passa  mscara seguinte
maisUm:	LD	[contador]	; bit  1. Vai buscar o valor actual do contador
	ADD	1			; incrementa-o
	ST	[contador]		; e actualiza de novo na memria
prximo:LD	[mscara]		; vai buscar de novo a mscara actual
	SUB	mscaraFinal	; subtrai para comparar com a mscara final
	JZ	fim			; se der zero, eram iguais e portanto j terminou
	LD	[mscara]		; tem de carregar a mscara de novo
	ADD	[mscara]		; soma com ela prpria para a multiplicar por 2
	ST	[mscara]		; actualiza o valor da mscara na memria
	JMP	teste			; vai fazer mais um teste com a nova mscara
fim:	JMP	fim			; fim do programa
